#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "classes.h"

/*
 * Killed function checks to see if we where killed by any monsters/bad stuff.
 */

int LIDL::killed()
{
#ifdef DEBUG
	printf("Entering killed.\n");
#endif
  switch(room[wherex][wherey])
  {
     case MONSTER: { printf("You where killed by LIDL.\n"); done=1; return TRUE; break; };
     case TRAP: {
     int type=1+(int) (4.0*rand()/(RAND_MAX+1.0));
     switch (type) {
     case 1: {printf("You fell into a trapdoor and died of starvation.\n"); break; };
     case 2: {printf("You where alive eaten by a dool.\n"); break; };
     case 3: {printf("You got crushed under under the roof that did land on you head.\n"); break; };
     case 4: {printf("It droped some cave acid on your tiny body and you melted away.\n"); break; };
     }
     done=1;
     return TRUE;
     break;
     };
     case BAT: { printf("One of your arrows was eaten alive by fruit eating bats.\nAnd the little pest flew away.\n"); room[wherex][wherey]= EMPTY; shots--; break; };
     case EMPTY: { printf("The room is empty.\n"); break; };
     default: { printf("Aiee, the room has a weird value %i.\n", room[wherex][wherey]); break; };
  }
#ifdef DEBUG
	printf("Room content: %i\n", room[wherex][wherey]);
#endif
	return FALSE;
}

/*
 * Surrounding checks all rooms around the room we just moved into and prints a warning
 * for each room around us that contains something bad.
 */

int LIDL::surroundings()
{
  if (done != 1)
    {
      int x,y;
#ifdef DEBUG
      printf("Entering surroundings.\n");
#endif
      for (x = -1; x <= 1; x = x+1)
	{
	  if (x>=0 && x<=maxx)
#ifdef DEBUG
	    printf("Entering x loop.\n");
#endif
	  for (y = -1; y <= 1; y = y+1)
	    {
#ifdef DEBUG
	      printf("Checking room[%i][%i] = %i\n", wherex+x, wherey+y, room[wherex+x][wherey+y]);
#endif
	      if (room[wherex+x][wherey+y] != EMPTY && wherex+x<=maxx && wherex+x>0 && wherey+y<=maxy && wherey+y>0)
		{
		  if (room[wherex+x][wherey+y] == MONSTER)
		    {
		      printf("You feel a gust of wind carrying the smell of rotting meat.\n The monster is near.\n");
		    }		  
		  else if (room[wherex+x][wherey+y] == TRAP)
		    {
		    //printf("You feel the smell of plastic roses. The plant department is close.\n"); // We do not want people to know that they might die!
		    }		  
		  else if (room[wherex+x][wherey+y] == BAT)
		    {		    
		      printf("The sweet smell of fruit warns you. The fruit eating bats are close.\n");
		    }
		  else
		    {
		      printf("Aiee, bad value in room %i, %i, value: %i\n", wherex+x, wherey+y, room[wherex+x][wherey+y]);
		    }
		}
	    }
	}
    }
}

/*
 * The legal_move function checks if the move we just tried to make is legal. 
 * Are we trying to move through one of the outer limits for example?
 */

int LIDL::legal_move()
{
	if ((direction == 110) && (wherex+1 > maxx)) // north border
	{
		printf("Bad move, you're trying to run into the northern wall of darkness.\n");
		return FALSE;
	} else if ((direction == 101) && (wherey+1 > maxy)) // east border
	{
		printf("Bad move, you're trying to run into the eastern wall of china.\n");
		return FALSE;
	} else if ((direction == 115) && (wherex-1 < 0)) // south border
	{
		printf("Bad move, you're trying to run into the southern wall of light.\n");
		return FALSE;
	} else if ((direction == 119) && (wherey-1 < 0)) // west border
	{
		printf("Bad move, you're trying to run into the western wall of dragons.\n");
		return FALSE;
	} else if ((direction != 110) && (direction != 101) && 
						(direction != 115) && (direction != 119)) {
		printf("Aieee, Bad move, you should not be here.\nDirection: %c, %i\n", direction, direction);
	} else {
		return TRUE;
	}
	return FALSE;
}

/*
 * This function is entered when the player decides to move the character through the 
 * labyrinth.
 */

void LIDL::move()
{
  printf("Move (n,e,s,w):");
  if (getchar()==10); // EOL can make things weird.

  while ((direction=getchar())!=10)
    {
      switch (direction)
	{
	case 110: {if (legal_move() == TRUE){wherex++;}break;} //e
	case 101: {if (legal_move() == TRUE){wherey++;}break;} //n
	case 115: {if (legal_move() == TRUE){wherex--;}break;} //s
	case 119: {if (legal_move() == TRUE){wherey--;}break;} //w
	default: {printf("Hmmm %c is not a supported way to go.\n",direction);break;}
	}
      
    }
}
