#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "classes.h"

/*
 * Check if the shot was a legal shot. Eg. are we trying to fire through the walls?
 */

int LIDL::legal_shot()
{
	if ((direction == 110) && (wherex+1 > maxx)) // north border
	{
		printf("Bad shot, if you continue , you may shoot yourself through \nthe northern wall of darkness?\n");
		return FALSE;
	} else if ((direction == 101) && (wherey+1 > maxy)) // east border
	{
		printf("Bad shot, if you continue , you may shoot yourself through \nthe eastern wall of china.\n");
		return FALSE;
	} else if ((direction == 115) && (wherex-1 < 0)) // south border
	{
		printf("Bad shot, if you continue , you may shoot yourself through \nthe southern wall of light.\n");
		return FALSE;
	} else if ((direction == 119) && (wherey-1 < 0)) // west border
	{
		printf("Bad shot, if you continue , you may shoot yourself through \nthe western wall of dragons.\n");
		return FALSE;
	} else if ((direction != 110) && (direction != 101) && (direction != 115) && (direction != 119)) {
		printf("Aieee, Bad shot, you should not be here.\nDirection: %c,%i\n",direction, direction);
	} else {
		return TRUE;
	}
	return FALSE;

}

/*
 * This is the function entered when we want to shoot. First choose where the player
 * wants to fire, then see if it was a hit.
 */

void LIDL::shoot()
{
	int OK=TRUE;
	printf("Shoot (n,e,s,w): ");

	
	
	//while((direction=getchar())!=10)
	// {

	   
	    while(OK == TRUE)
	      {
		direction=getchar();
		if (direction == 10) // EOL can make things weird.
		  {
		    OK = TRUE;
		  }
		else if (direction != 110 && direction != 101 && direction != 115 && direction != 119)
		  { 	// If this is not a valid command, print an error and read a new char
		    OK = TRUE;
		    printf("Bad command %c, %i\n", direction, direction);
		  } else { //		Otherwise this should be a valid command. Leave loop.
		    OK = FALSE;
		  }
	      }
	    
#ifdef DEBUG
	printf("direction: %c, int: %i\n", direction, direction);
#endif

	switch (direction)
	{
		case 110: //north
		{
			if (legal_shot() == TRUE)
			{
				switch(room[wherex-1][wherey])
      				{
         			   case MONSTER: { printf("You killed the monster!\nCongratulations!\n"); done=1; points=points+5;break; };
				   case BAT: { printf("You killed a fruit eating bat\n"); shots--;  room[wherex-1][wherey]=EMPTY;points++;break; };
				   default: { printf("What are you shooting at? There is nothing there!\n"); shots--;points--; break; };
				}
			}
		break;
		}
		case 101: //east
		{
			if (legal_shot() == TRUE)
			{
				switch(room[wherex][wherey+1])
      				{
         			   case MONSTER: { printf("You killed the monster!\nCongratulations!\n"); done=1; points=points+5;break; };
				   case BAT: { printf("You killed a fruit eating bat\n"); shots--;  room[wherex][wherey+1]=EMPTY;points++;break; };
				   default: { printf("What are you shooting at? There is nothing there!\n"); shots--;points--; break; };
				}
			}
		break;
		}
		case 115: //south
		{
			if (legal_shot() == TRUE)
			{
					switch(room[wherex+1][wherey])
      				{
         			   case MONSTER: { printf("You killed the monster!\nCongratulations!\n"); done=1; points=points+5; break; };
				   case BAT: { printf("You killed a fruit eating bat\n"); shots--;  room[wherex+1][wherey]=EMPTY; points++; break; };
				   default: { printf("What are you shooting at? There is nothing there!\n"); shots--; points--; break; };
				}
			}
		break;
		}
		case 119: //west
		{
			if (legal_shot() == TRUE)
			{
				switch(room[wherex][wherey-1])
      				{
         			   case MONSTER: { printf("You killed the monster!\nCongratulations!\n"); done=1;points=points+5; break; };
				   case BAT: { printf("You killed a fruit eating bat\n"); shots--; room[wherex][wherey-1]=EMPTY;points++;break; };
				   default: { printf("What are you shooting at? There is nothing there!\n"); shots--;points--;break; };
				}
			}
		break;
		}
	}

	if (shots<=0)
		{
			printf("The baby lidl monsters of this cave found you when you didn't have a arrow left and they are planing to gnaw you heels of...\n");
			done=1;
		}
}
